use crate::{state::{GameState, Action}, creature::Creature, site::Town};

pub struct PersonGenesis {
    pub town: Town,
    pub person: Creature,
}

impl Action for PersonGenesis {
    fn apply(&self, state: &mut GameState) {
        let person_id = state.add_person(self.person.clone());
        state.add_coins(person_id, 100);
    }

    fn description(&self) -> String {
        format!("{} was sent by the Gods to {}", self.person.name, self.town.name)
    }

    fn notable(&self) -> bool {
        true
    }
}