
use crate::{state::{GameState, Action}, site::{Structure, Tavern, Site}, entity::{Location, Entity}};

pub struct TavernBuilt {
    pub loc: Location,
    pub tavern: Tavern,
}

impl Action for TavernBuilt {
    fn apply(&self, state: &mut GameState) {
        let tavern_id = state.world.add_site(Site{
            entity: Entity::new_site(),
            loc: self.loc,
            structure: Structure::Tavern(self.tavern.clone()),
            coins: 0,
        });
        state.set_tavern(tavern_id);
    }

    fn description(&self) -> String {
        format!("{} was built", self.tavern.name)
    }

    fn notable(&self) -> bool {
        true
    }
}