use tui::{Frame, backend::Backend};

use crate::game::Game;

pub struct StatusLine {}


impl StatusLine {
    pub fn draw<B: Backend>(f: &mut Frame<B>, rect: tui::layout::Rect, game: &Game) {

        let tavern = game.state.world.get_site(
            game.state.tavern.unwrap()
        ).unwrap();

        let spans = tui::text::Spans::from(vec![
            tui::text::Span::raw("Date: "),
            tui::text::Span::raw(format!("{}", game.state.time)),
            tui::text::Span::raw("    "),
            tui::text::Span::raw("Funds: "),
            tui::text::Span::raw(format!("{} gold coins", tavern.coins)),
        ]);

        let status_text = tui::widgets::Paragraph::new(spans)
            .block(tui::widgets::Block::default().borders(tui::widgets::Borders::LEFT | tui::widgets::Borders::RIGHT))
            .style(tui::style::Style::default().fg(tui::style::Color::White));

        f.render_widget(status_text, rect);
    }
}